<script lang="ts" setup>
    import {definePageMeta} from "../../.nuxt/imports";
    import {useErrorStore} from "../../stores/useErrorStore";

    definePageMeta({
        middleware: ['auth']
    })



    const deletingId = ref<number|null>(null);


    const errorStore = useErrorStore();

    async function doDelete() {
        if(!deletingId.value){
            return
        }
        try {
            const { data, error } = await useCustomFetch(`/api/stars/${deletingId.value}`, {
                method: "DELETE"
            })
            if (error.value || !data.value.success) {
                errorStore.setError(data.value.message || 'An unknown error occurred');
            }
        } catch(error){
            if (error) {
                errorStore.setError(error || 'An error occurred');
            }
        }
        deletingId.value = null;
    }
</script>

<template>
  <div>
    <NuxtLink to="/admin/star" class="button inline-flex">
      <svg
        xmlns="http://www.w3.org/2000/svg"
        fill="none"
        viewBox="0 0 24 24"
        stroke-width="1.5"
        stroke="currentColor"
        class="w-6 h-6 mr-2"
      >
        <path
          stroke-linecap="round"
          stroke-linejoin="round"
          d="M12 9v6m3-3H9m12 0a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
        />
      </svg>
      Create
    </NuxtLink>
      <h1 class="text-xl font-bold mt-4 mb-4">List stars</h1>
    <ListStars from-admin>
      <template #default="{ star }">
          <div class="w-1/3">
              <NuxtLink
                  :to="`/admin/star/${star.id}`"
                  class="button inline-flex cursor-pointer"
              >
                  <svg
                      xmlns="http://www.w3.org/2000/svg"
                      fill="none"
                      viewBox="0 0 24 24"
                      stroke-width="1.5"
                      stroke="currentColor"
                      class="w-6 h-6 mr-2"
                  >
                      <path
                          stroke-linecap="round"
                          stroke-linejoin="round"
                          d="m16.862 4.487 1.687-1.688a1.875 1.875 0 1 1 2.652 2.652L10.582 16.07a4.5 4.5 0 0 1-1.897 1.13L6 18l.8-2.685a4.5 4.5 0 0 1 1.13-1.897l8.932-8.931Zm0 0L19.5 7.125M18 14v4.75A2.25 2.25 0 0 1 15.75 21H5.25A2.25 2.25 0 0 1 3 18.75V8.25A2.25 2.25 0 0 1 5.25 6H10"
                      />
                  </svg>Edit
              </NuxtLink>
          </div>

        <div
          class="w-1/3"
        >
         <div class="button delete cursor-pointer inline-flex"
              @click="deletingId = star.id"
              v-if="!deletingId || (deletingId && deletingId !== star.id)">
             <svg
                 xmlns="http://www.w3.org/2000/svg"
                 fill="none"
                 viewBox="0 0 24 24"
                 stroke-width="1.5"
                 stroke="currentColor"
                 class="w-6 h-6 mr-2"
             >
                 <path
                     stroke-linecap="round"
                     stroke-linejoin="round"
                     d="m14.74 9-.346 9m-4.788 0L9.26 9m9.968-3.21c.342.052.682.107 1.022.166m-1.022-.165L18.16 19.673a2.25 2.25 0 0 1-2.244 2.077H8.084a2.25 2.25 0 0 1-2.244-2.077L4.772 5.79m14.456 0a48.108 48.108 0 0 0-3.478-.397m-12 .562c.34-.059.68-.114 1.022-.165m0 0a48.11 48.11 0 0 1 3.478-.397m7.5 0v-.916c0-1.18-.91-2.164-2.09-2.201a51.964 51.964 0 0 0-3.32 0c-1.18.037-2.09 1.022-2.09 2.201v.916m7.5 0a48.667 48.667 0 0 0-7.5 0"
                 />
             </svg>Delete
         </div>
            <div v-if="deletingId && deletingId === star.id" class="bg-stone-300 px-4 py-2">
                Are you sure ?
                <div class="flex justify-between">
                    <div @click="doDelete" class="button small delete">
                        Yes
                    </div>
                    <div @click.stop="deletingId = null" class="button small">
                        No
                    </div>
                </div>
            </div>
        </div>
      </template>
    </ListStars>
  </div>
</template>

<style scoped></style>
